;CW KEYBOARD v3.2  21-FEB-2004
;
;Babushkin Anton RK3DOV
;	mailto:rk3dov@mail.ru
;	http://www.qsl.net/rk3dov
;
;==============================================================
;Procedure INSERT MACRO - input from EEPROM
;INPUT: q - offset
;PORTIT: i,s,q
;==============================================================

insmacro:
		in i,EECR
		andi i,2
		cpi i,0
		brne insmacro	;wait for ready

		out EEAR,q	;address
		ldi i,1
		out EECR,i
		in s,EEDR

		cpi s,0xFF
		breq ws

	cpi s,0x03	;For F5
	brne gg		;macro in macro

	    mov tm,q
	    ldi q,0
	    rcall insmacro
	    mov q,tm
	    rjmp con0

gg:	cpi s,0x7C	;For PrintScreen=NOM++
	brne gg1		;macro in macro

	    rcall incnom
	    rjmp con0

gg1:	cpi s,0x0A	;For F8 macro in macro
	brne gg2

	    rcall getnr
	    rjmp con0

gg2:

	mov t,s
	rcall outbuf

con0:	inc q
	cpi q,16
	breq ws
	cpi q,48
	breq ws
	cpi q,80
	breq ws
	cpi q,112
	breq ws
	cpi q,128
	breq ws
	rjmp insmacro

ws:
ret
